; StrCompare    Compare two strings
;---------------------------------------------------------------
; Output:
;       flags set for conditional jump using jb, jbe,
;        je, ja, or jae.
;   jz  ।
proc StrCompare,String1,String2
enter
        push    eax              ; Save modified registers
        push    edi
        push    esi
        push    eax

mov esi, [String1]
mov edi, [String2]
        cld                      ; Auto-increment si
@@10:
        lodsb                    ; al <- [si], si <- si + 1
        scasb                    ; Compare al and [di]; di <- di + 1
        jne     @@20             ; Exit if non-equal chars found
        or      al, al           ; Is al=0? (i.e. at end of s1)
        jne     @@10             ; If no jump, else exit
@@20:
        pop     eax
        pop     esi              ; Restore registers
        pop     edi
        pop     eax
return                           ; Return flags to caller


